diff --git a/src/tcs/tcsi_dir.c b/src/tcs/tcsi_dir.c
index 9d5030a..6eeff0f 100644
--- a/src/tcs/tcsi_dir.c
+++ b/src/tcs/tcsi_dir.c
@@ -12,7 +12,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/tcsi_ek.c b/src/tcs/tcsi_ek.c
index 34388da..9dc2862 100644
--- a/src/tcs/tcsi_ek.c
+++ b/src/tcs/tcsi_ek.c
@@ -12,7 +12,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/tcsi_evlog.c b/src/tcs/tcsi_evlog.c
index 355f30a..2892cdd 100644
--- a/src/tcs/tcsi_evlog.c
+++ b/src/tcs/tcsi_evlog.c
@@ -77,11 +77,11 @@ TCS_GetExternalPcrEvent(UINT32 PcrIndex,		/* in */
 
 			if (tcs_event_log->kernel_source->get_entry(log_handle, PcrIndex,
 						pNumber, ppEvent)) {
-				tcs_event_log->kernel_source->close(log_handle);
+				tcs_event_log->kernel_source->file_close(log_handle);
 				return TCSERR(TSS_E_INTERNAL_ERROR);
 			}
 
-			tcs_event_log->kernel_source->close(log_handle);
+			tcs_event_log->kernel_source->file_close(log_handle);
 		} else {
 			LogError("No source for externel kernel events was compiled in, but "
 					"the tcsd is configured to use one! (see %s)",
@@ -97,11 +97,11 @@ TCS_GetExternalPcrEvent(UINT32 PcrIndex,		/* in */
 
 			if (tcs_event_log->firmware_source->get_entry(log_handle, PcrIndex,
 						pNumber, ppEvent)) {
-				tcs_event_log->firmware_source->close(log_handle);
+				tcs_event_log->firmware_source->file_close(log_handle);
 				return TCSERR(TSS_E_INTERNAL_ERROR);
 			}
 
-			tcs_event_log->firmware_source->close(log_handle);
+			tcs_event_log->firmware_source->file_close(log_handle);
 		} else {
 			LogError("No source for externel firmware events was compiled in, but "
 					"the tcsd is configured to use one! (see %s)",
@@ -192,11 +192,11 @@ TCS_GetExternalPcrEventsByPcr(UINT32 PcrIndex,		/* in */
 
 			if (tcs_event_log->kernel_source->get_entries_by_pcr(log_handle, PcrIndex,
 						FirstEvent, pEventCount, ppEvents)) {
-				tcs_event_log->kernel_source->close(log_handle);
+				tcs_event_log->kernel_source->file_close(log_handle);
 				return TCSERR(TSS_E_INTERNAL_ERROR);
 			}
 
-			tcs_event_log->kernel_source->close(log_handle);
+			tcs_event_log->kernel_source->file_close(log_handle);
 		} else {
 			LogError("No source for externel kernel events was compiled in, but "
 					"the tcsd is configured to use one! (see %s)",
@@ -212,11 +212,11 @@ TCS_GetExternalPcrEventsByPcr(UINT32 PcrIndex,		/* in */
 
 			if (tcs_event_log->firmware_source->get_entries_by_pcr(log_handle, PcrIndex,
 						FirstEvent, pEventCount, ppEvents)) {
-				tcs_event_log->firmware_source->close(log_handle);
+				tcs_event_log->firmware_source->file_close(log_handle);
 				return TCSERR(TSS_E_INTERNAL_ERROR);
 			}
 
-			tcs_event_log->firmware_source->close(log_handle);
+			tcs_event_log->firmware_source->file_close(log_handle);
 		} else {
 			LogError("No source for externel firmware events was compiled in, but "
 					"the tcsd is configured to use one! (see %s)",
diff --git a/src/tcs/tcsi_maint.c b/src/tcs/tcsi_maint.c
index fea756d..f33d4d5 100644
--- a/src/tcs/tcsi_maint.c
+++ b/src/tcs/tcsi_maint.c
@@ -12,7 +12,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/tcsi_migration.c b/src/tcs/tcsi_migration.c
index 8467f02..f1b3b48 100644
--- a/src/tcs/tcsi_migration.c
+++ b/src/tcs/tcsi_migration.c
@@ -12,7 +12,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/tcsi_nv.c b/src/tcs/tcsi_nv.c
index cd88f20..e845436 100644
--- a/src/tcs/tcsi_nv.c
+++ b/src/tcs/tcsi_nv.c
@@ -27,7 +27,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/tcsi_pcr.c b/src/tcs/tcsi_pcr.c
index 2cb97e3..9ab976b 100644
--- a/src/tcs/tcsi_pcr.c
+++ b/src/tcs/tcsi_pcr.c
@@ -13,7 +13,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/tcsi_quote.c b/src/tcs/tcsi_quote.c
index 632b0cc..b56eddd 100644
--- a/src/tcs/tcsi_quote.c
+++ b/src/tcs/tcsi_quote.c
@@ -12,7 +12,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/tcsi_quote2.c b/src/tcs/tcsi_quote2.c
index 0ced27f..f420d44 100644
--- a/src/tcs/tcsi_quote2.c
+++ b/src/tcs/tcsi_quote2.c
@@ -12,7 +12,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/tcsi_random.c b/src/tcs/tcsi_random.c
index 9670df4..b1cdeb0 100644
--- a/src/tcs/tcsi_random.c
+++ b/src/tcs/tcsi_random.c
@@ -12,7 +12,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/tcsi_seal.c b/src/tcs/tcsi_seal.c
index bc72ecd..aea71c6 100644
--- a/src/tcs/tcsi_seal.c
+++ b/src/tcs/tcsi_seal.c
@@ -12,7 +12,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/tcsi_selftest.c b/src/tcs/tcsi_selftest.c
index 95869bc..4887bd2 100644
--- a/src/tcs/tcsi_selftest.c
+++ b/src/tcs/tcsi_selftest.c
@@ -12,7 +12,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcs/tcsi_sign.c b/src/tcs/tcsi_sign.c
index 3671fb1..3266818 100644
--- a/src/tcs/tcsi_sign.c
+++ b/src/tcs/tcsi_sign.c
@@ -12,7 +12,9 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
diff --git a/src/tcsd/Makefile.am b/src/tcsd/Makefile.am
index ff61a21..3ed3eb8 100644
--- a/src/tcsd/Makefile.am
+++ b/src/tcsd/Makefile.am
@@ -1,10 +1,14 @@
 sbin_PROGRAMS=tcsd
 
 tcsd_CFLAGS=-DAPPID=\"TCSD\" -DVAR_PREFIX=\"@localstatedir@\" -DETC_PREFIX=\"@sysconfdir@\" -I${top_srcdir}/src/include
-tcsd_LDADD=${top_builddir}/src/tcs/libtcs.a ${top_builddir}/src/tddl/libtddl.a -lpthread @CRYPTOLIB@
+tcsd_LDADD=${top_builddir}/src/tcs/libtcs.a ${top_builddir}/src/tddl/libtddl.a -lpthread @CRYPTOLIB@ @EXTRATCSLIB@
 
 tcsd_SOURCES=svrside.c tcsd_conf.c tcsd_threads.c platform.c
 
+if OS_WIN32
+tcsd_LDADD+=${top_builddir}/src/win32/libc_interface.la
+tcsd_CFLAGS+=-DDEBUG_APP
+endif
 if TSS_BUILD_PS
 tcsd_CFLAGS+=-DTSS_BUILD_PS
 endif
diff --git a/src/tcsd/platform.c b/src/tcsd/platform.c
index c7a1c80..c54e830 100644
--- a/src/tcsd/platform.c
+++ b/src/tcsd/platform.c
@@ -19,7 +19,9 @@
 #include <utmpx.h>
 #endif
 
+#ifndef WIN32
 #include <sys/time.h>
+#endif
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
diff --git a/src/tcsd/svrside.c b/src/tcsd/svrside.c
index 27c18bf..9a2ea8b 100644
--- a/src/tcsd/svrside.c
+++ b/src/tcsd/svrside.c
@@ -9,11 +9,18 @@
  */
 
 
+#ifdef WIN32
+#include <ws2tcpip.h>
+#include <windows.h>
+#endif
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <unistd.h>
+#endif
 #include <string.h>
 #include <sys/types.h>
+#ifndef WIN32
 #include <sys/time.h>
 #include <sys/resource.h>
 #include <sys/wait.h>
@@ -21,10 +28,13 @@
 #include <sys/socket.h>
 #include <netdb.h>
 #include <pwd.h>
+#endif
 #if (defined (__OpenBSD__) || defined (__FreeBSD__))
 #include <netinet/in.h>
 #endif
+#ifndef WIN32
 #include <arpa/inet.h>
+#endif
 #include <errno.h>
 #include <getopt.h>
 #include "trousers/tss.h"
@@ -38,11 +48,19 @@
 #include "tcsps.h"
 #include "tcsd.h"
 #include "req_mgr.h"
+#ifdef WIN32
+#include "win32dep.h"
+#include "libc_interface.h"
+#define SERVICE_NAME		"tcsd"
+#define WIN32_LEAN_AND_MEAN
+#include <tchar.h>
+#endif
 
 struct tcsd_config tcsd_options;
 struct tpm_properties tpm_metrics;
 static volatile int hup = 0, term = 0;
 extern char *optarg;
+int sd = -1;
 
 static void
 tcsd_shutdown(void)
@@ -61,6 +79,8 @@ static void
 tcsd_signal_term(int signal)
 {
 	term = 1;
+	close(sd);
+	sd = -1;
 }
 
 void
@@ -69,9 +89,95 @@ tcsd_signal_hup(int signal)
 	hup = 1;
 }
 
+#ifdef WIN32
+int serviceflag = 0;
+SERVICE_STATUS_HANDLE serviceStatusHandle;
+HANDLE killServiceEvent = INVALID_HANDLE_VALUE;
+BOOL serviceRunning = 0;
+BOOL servicePaused = 0;
+DWORD serviceCurrentStatus;
+
+/************************************************************************/
+/* UpdateSCMStatus							*/
+/************************************************************************/
+BOOL UpdateSCMStatus (DWORD dwCurrentState,
+					  DWORD dwWin32ExitCode,
+					  DWORD dwServiceSpecificExitCode,
+					  DWORD dwCheckPoint,
+					  DWORD dwWaitHint)
+{
+	BOOL success;
+	SERVICE_STATUS serviceStatus;
+
+	if (serviceflag == 0)
+		return TRUE;
+
+	serviceCurrentStatus = dwCurrentState;
+	serviceStatus.dwServiceType = SERVICE_WIN32_OWN_PROCESS;
+	serviceStatus.dwCurrentState = dwCurrentState;
+
+	if (dwCurrentState == SERVICE_START_PENDING)
+		serviceStatus.dwControlsAccepted = 0;
+	else {
+		serviceStatus.dwControlsAccepted =
+			SERVICE_ACCEPT_STOP |
+			//SERVICE_ACCEPT_PAUSE_CONTINUE |
+			SERVICE_ACCEPT_SHUTDOWN;
+	}
+
+	if (dwServiceSpecificExitCode == 0)
+		serviceStatus.dwWin32ExitCode = dwWin32ExitCode;
+	else
+		serviceStatus.dwWin32ExitCode = ERROR_SERVICE_SPECIFIC_ERROR;
+
+	serviceStatus.dwServiceSpecificExitCode = dwServiceSpecificExitCode;
+	serviceStatus.dwCheckPoint = dwCheckPoint;
+	serviceStatus.dwWaitHint = dwWaitHint;
+
+	success = SetServiceStatus (serviceStatusHandle, &serviceStatus);
+	if (!success)
+		return FALSE;
+
+	return success;
+}
+
+BOOL signal_handler(DWORD event)
+{
+	tcsd_signal_term(0);
+	return TRUE;
+}
+
+/************************************************************************/
+/* ServiceCtrlHandler							*/
+/************************************************************************/
+VOID ServiceCtrlHandler (DWORD controlCode)
+{
+	BOOL success;
+	switch(controlCode)
+	{
+
+	case SERVICE_CONTROL_PAUSE:
+		break;
+	case SERVICE_CONTROL_CONTINUE:
+		break;
+	case SERVICE_CONTROL_INTERROGATE:
+		break;
+	case SERVICE_CONTROL_STOP:
+	case SERVICE_CONTROL_SHUTDOWN:
+		success = UpdateSCMStatus(SERVICE_STOP_PENDING, NO_ERROR, 0, 1, 5000);
+		signal_handler(CTRL_CLOSE_EVENT);
+		return;
+	default:
+		break;
+	}
+	UpdateSCMStatus(serviceCurrentStatus, NO_ERROR, 0, 0, 0);
+}
+#endif
+
 static TSS_RESULT
 signals_init(void)
 {
+#ifndef WIN32
 	int rc;
 	sigset_t sigmask;
 	struct sigaction sa;
@@ -104,6 +210,13 @@ signals_init(void)
 		LogError("signal SIGHUP not registered: %s", strerror(errno));
 		return TCSERR(TSS_E_INTERNAL_ERROR);
 	}
+#else
+	if (!SetConsoleCtrlHandler((PHANDLER_ROUTINE)signal_handler,TRUE)) {
+		LogError("SetConsoleCtrlHandler() failed: %s", strerror(errno));
+		return TCSERR(TSS_E_INTERNAL_ERROR);
+	}
+	return 0;
+#endif
 
 	return TSS_SUCCESS;
 }
@@ -208,47 +321,54 @@ reload_config(void)
 }
 
 
-int
-main(int argc, char **argv)
+void
+tcsd_main(int argc, char **argv)
 {
 	struct sockaddr_in serv_addr, client_addr;
-	TSS_RESULT result;
-	int sd, newsd, c, option_index = 0;
-	unsigned client_len;
+	TSS_RESULT result = TSS_SUCCESS;
+	int newsd, c;
+	socklen_t client_len;
 	char *hostname = NULL;
-	struct passwd *pwd;
 	struct hostent *client_hostent = NULL;
-	struct option long_options[] = {
-		{"help", 0, NULL, 'h'},
-		{"foreground", 0, NULL, 'f'},
-		{0, 0, 0, 0}
-	};
-
-	unsetenv("TCSD_USE_TCP_DEVICE");
-	while ((c = getopt_long(argc, argv, "fhe", long_options, &option_index)) != -1) {
-		switch (c) {
-			case 'f':
-				setenv("TCSD_FOREGROUND", "1", 1);
-				break;
-			case 'h':
-				/* fall through */
-			case 'e':
-				setenv("TCSD_USE_TCP_DEVICE", "1", 1);
-				break;
-			default:
-				usage();
-				return -1;
-				break;
+	
+#ifdef WIN32
+	BOOL success = 0;
+	WSADATA wsaData;
+
+	/* Registers ServiceCtrlHandler function to handle service control 
+	 * requests. The return value is the service status handle. */
+	if (serviceflag == 1) {
+		serviceStatusHandle = RegisterServiceCtrlHandler((LPTSTR)SERVICE_NAME,
+			(LPHANDLER_FUNCTION) ServiceCtrlHandler);
+		if (serviceStatusHandle == 0) {
+			LogError("RegisterServiceCtrlHandler() failed: %s", strerror(errno));
+			goto outlast;
 		}
 	}
 
-	if ((result = tcsd_startup()))
-		return (int)result;
+	/* SCM is notified that the service is in state START PENDING */
+	success = UpdateSCMStatus(SERVICE_START_PENDING, NO_ERROR, 0, 1, 5000);
+	if (!success) {
+		LogError("UpdateSCMStatus() failed");
+		goto outlast;
+	}
+
+	result = WSAStartup(MAKEWORD(2,2), &wsaData);
+	if(result) {
+		LogError("WSAStartup failed.");	
+		goto outlast;
+	}
+#endif
+
+	if ((result = tcsd_startup())) {
+		LogError("tcsd_startup failed: %d", result);
+		goto outlast;
+	}
 
 	sd = socket(AF_INET, SOCK_STREAM, 0);
 	if (sd < 0) {
 		LogError("Failed socket: %s", strerror(errno));
-		return -1;
+		goto out;
 	}
 
 	memset(&serv_addr, 0, sizeof (serv_addr));
@@ -266,35 +386,23 @@ main(int argc, char **argv)
 	setsockopt(sd, SOL_SOCKET, SO_REUSEADDR, &c, sizeof(c));
 	if (bind(sd, (struct sockaddr *) &serv_addr, sizeof (serv_addr)) < 0) {
 		LogError("Failed bind: %s", strerror(errno));
-		return -1;
+		goto out;
 	}
-#ifndef SOLARIS
-	pwd = getpwnam(TSS_USER_NAME);
-	if (pwd == NULL) {
-		if (errno == 0) {
-			LogError("User \"%s\" not found, please add this user"
-					" manually.", TSS_USER_NAME);
-		} else {
-			LogError("getpwnam(%s): %s", TSS_USER_NAME, strerror(errno));
-		}
-		return TCSERR(TSS_E_INTERNAL_ERROR);
-	}
-	setuid(pwd->pw_uid);
-#endif
+
 	if (listen(sd, TCSD_MAX_SOCKETS_QUEUED) < 0) {
 		LogError("Failed listen: %s", strerror(errno));
-		return -1;
+		goto out;
 	}
 	client_len = (unsigned)sizeof(client_addr);
-	
-	if (getenv("TCSD_FOREGROUND") == NULL) {
-		if (daemon(0, 0) == -1) {
-			perror("daemon");
-			tcsd_shutdown();
-			return -1;
-		}
-	}
 
+#ifdef WIN32
+	/* SCM is notified that the service is still in the state RUNNING */
+	success = UpdateSCMStatus(SERVICE_RUNNING, NO_ERROR, 0, 0, 0);
+	if (!success){
+		LogError("UpdateSCMStatus() failed");
+		goto out;
+	}
+#endif
 	LogInfo("%s: TCSD up and running.", PACKAGE_STRING);
 	do {
 		newsd = accept(sd, (struct sockaddr *) &client_addr, &client_len);
@@ -318,7 +426,7 @@ main(int argc, char **argv)
 						    sizeof(client_addr.sin_addr),
 						    AF_INET)) == NULL) {
 			char buf[16];
-                        uint32_t addr = htonl(client_addr.sin_addr.s_addr);
+                        UINT32 addr = htonl(client_addr.sin_addr.s_addr);
 
                         snprintf(buf, 16, "%d.%d.%d.%d", (addr & 0xff000000) >> 24,
                                  (addr & 0x00ff0000) >> 16, (addr & 0x0000ff00) >> 8,
@@ -339,5 +447,91 @@ main(int argc, char **argv)
 	} while (term ==0);
 
 	/* To close correctly, we must receive a SIGTERM */
+out:
+	if (term != 1)
+		result = GetLastError();
+	if (sd != -1)
+		close(sd);
+	tcsd_shutdown();
+#ifdef WIN32
+	WSACleanup();
+outlast:
+	UpdateSCMStatus(SERVICE_STOPPED, result,0,0,0);
+#endif
+	return;
+} 
+
+int
+main(int argc, char **argv)
+{
+	int c, option_index = 0;
+#if (!defined SOLARIS && !defined WIN32)
+	struct passwd *pwd;
+#endif
+
+	struct option long_options[] = {
+		{"help", 0, NULL, 'h'},
+		{"foreground", 0, NULL, 'f'},
+		{0, 0, 0, 0}
+	};
+
+	unsetenv("TCSD_USE_TCP_DEVICE");
+	while ((c = getopt_long(argc, argv, "fhe", long_options, &option_index)) != -1) {
+		switch (c) {
+			case 'f':
+				setenv("TCSD_FOREGROUND", "1", 1);
+				break;
+			case 'h':
+			case 'e':
+				setenv("TCSD_USE_TCP_DEVICE", "1", 1);
+				break;
+			default:
+				usage();
+				return -1;
+				break;
+		}
+	}
+
+#if !defined SOLARIS && !defined WIN32
+	pwd = getpwnam(TSS_USER_NAME);
+	if (pwd == NULL) {
+		if (errno == 0) {
+			LogError("User \"%s\" not found, please add this user"
+					" manually.", TSS_USER_NAME);
+		} else {
+			LogError("getpwnam(%s): %s", TSS_USER_NAME, strerror(errno));
+		}
+		return TCSERR(TSS_E_INTERNAL_ERROR);
+	}
+	setuid(pwd->pw_uid);
+#endif
+	if (getenv("TCSD_FOREGROUND") == NULL) {
+#ifdef WIN32
+		SERVICE_TABLE_ENTRY serviceTable[] = {
+			{ (LPTSTR)SERVICE_NAME, (LPSERVICE_MAIN_FUNCTION)tcsd_main },
+			{ NULL, NULL } };
+		int result;
+
+		serviceflag = 1;
+
+		/* Connects the main thread of a service process to the service 
+		* control manager, which causes the thread to be the service control 
+		* dispatcher thread for the calling process (in our case the ServiceMain) 
+		* If the function succeeds, the return value is nonzero */
+		result = StartServiceCtrlDispatcher(serviceTable);
+		if (result == 0) {
+	  		LogError("StartServiceCtrlDispatcher() failed: %s", strerror(errno));
+			return -1;
+		}
+
+		return TSS_SUCCESS;
+#else
+		if (daemon(0, 0) == -1) {
+			perror("daemon");
+			return -1;
+		}
+#endif
+	}
+	tcsd_main(0, NULL);
 	return 0;
 }
diff --git a/src/tcsd/tcsd_conf.c b/src/tcsd/tcsd_conf.c
index fbb6d1a..c2cd650 100644
--- a/src/tcsd/tcsd_conf.c
+++ b/src/tcsd/tcsd_conf.c
@@ -9,18 +9,32 @@
  */
 
 
+#ifdef WIN32
+#include <ws2tcpip.h>
+#include <windows.h>
+#endif
 #include <stdio.h>
+#ifndef WIN32
 #include <pwd.h>
+#endif
 #include <sys/types.h>
 #include <sys/stat.h>
 #include <fcntl.h>
 #include <ctype.h>
 #include <string.h>
+#ifndef WIN32
 #include <strings.h>
+#endif
 #include <errno.h>
+#ifndef WIN32
 #include <grp.h>
+#endif
 #include <stdlib.h>
 
+#ifdef WIN32
+#include <direct.h>
+#include "libc_interface.h"
+#endif
 #ifdef SOLARIS
 #include <libscf.h>
 #endif
@@ -307,7 +321,7 @@ read_conf_line(char *buf, int line_num, struct tcsd_config *conf)
 	case opt_firmware_pcrs:
 		conf->unset &= ~TCSD_OPTION_FIRMWARE_PCRS;
 		while (1) {
-			comma = rindex(arg, ',');
+			comma = strrchr(arg, ',');
 
 			if (comma == NULL) {
 				if (!isdigit(*arg))
@@ -336,7 +350,7 @@ read_conf_line(char *buf, int line_num, struct tcsd_config *conf)
 	case opt_kernel_pcrs:
 		conf->unset &= ~TCSD_OPTION_KERNEL_PCRS;
 		while (1) {
-			comma = rindex(arg, ',');
+			comma = strrchr(arg, ',');
 
 			if (comma == NULL) {
 				if (!isdigit(*arg))
@@ -388,7 +402,7 @@ read_conf_line(char *buf, int line_num, struct tcsd_config *conf)
 				free(conf->system_ps_dir);
 
 			/* break out the system ps directory from the file path */
-			dir_ptr = rindex(tmp_ptr, '/');
+			dir_ptr = strrchr(tmp_ptr, '/');
 			*dir_ptr = '\0';
 			if (strlen(tmp_ptr) == 0)
 				conf->system_ps_dir = strdup("/");
@@ -537,10 +551,10 @@ read_conf_line(char *buf, int line_num, struct tcsd_config *conf)
 		break;
 	case opt_remote_ops:
 		conf->unset &= ~TCSD_OPTION_REMOTE_OPS;
-		comma = rindex(arg, '\n');
+		comma = strrchr(arg, '\n');
 		*comma = '\0';
 		while (1) {
-			comma = rindex(arg, ',');
+			comma = strrchr(arg, ',');
 
 			if (comma == NULL) {
 				comma = arg;
@@ -576,10 +590,10 @@ read_conf_line(char *buf, int line_num, struct tcsd_config *conf)
 	case opt_host_platform_class:
 		/* append the host class on the list */
 		conf->unset &= ~TCSD_OPTION_HOST_PLATFORM_CLASS;
-		comma = rindex(arg,'\n');
+		comma = strrchr(arg,'\n');
 		*comma = '\0';
 
-		comma = rindex(arg,',');
+		comma = strrchr(arg,',');
 		/* At least one comma: error - more than one host class defined */
 		if (comma != NULL) {
 			LogError("Config option \"host_platform_class\" error: more than one "
@@ -597,10 +611,10 @@ read_conf_line(char *buf, int line_num, struct tcsd_config *conf)
 		break;
 	case opt_all_platform_classes:
 		/* append each of the comma separated values on the list */
-		comma = rindex(arg, '\n');
+		comma = strrchr(arg, '\n');
 		*comma = '\0';
 		while (1) {
-			comma = rindex(arg, ',');
+			comma = strrchr(arg, ',');
 
 			if (comma == NULL) {
 				comma = arg;
@@ -706,7 +720,7 @@ conf_file_init(struct tcsd_config *conf)
 {
 	FILE *f = NULL;
 	struct stat stat_buf;
-#ifndef SOLARIS
+#if (!defined SOLARIS && !defined WIN32)
 	struct group *grp;
 	struct passwd *pw;
 	mode_t mode = (S_IRUSR|S_IWUSR);
@@ -736,7 +750,7 @@ conf_file_init(struct tcsd_config *conf)
 		}
 	}
 
-#ifndef SOLARIS
+#if (!defined SOLARIS && !defined WIN32)
 	/* find the gid that owns the conf file */
 	errno = 0;
 	grp = getgrnam(TSS_GROUP_NAME);
@@ -805,7 +819,9 @@ TSS_RESULT
 ps_dirs_init()
 {
 	struct stat stat_buf;
+#ifndef WIN32
 	mode_t mode = S_IRWXU; /* 0700 */
+#endif
 
 	/* query the key storage directory to make sure it exists and is of the right mode */
 	if (stat(tcsd_options.system_ps_dir, &stat_buf) == -1) {
@@ -832,6 +848,7 @@ ps_dirs_init()
 		return TCSERR(TSS_E_INTERNAL_ERROR);
 	}
 
+#ifndef WIN32 
 	/* tcsd_options.system_ps_dir should be a directory with mode equal to mode */
 	if (!S_ISDIR(stat_buf.st_mode)) {
 		LogError("PS dir %s is not a directory! Exiting.", tcsd_options.system_ps_dir);
@@ -846,6 +863,9 @@ ps_dirs_init()
 			return TCSERR(TSS_E_INTERNAL_ERROR);
 		}
 	}
+#else
+	
+#endif
 
 	return TSS_SUCCESS;
 }
diff --git a/src/tcsd/tcsd_threads.c b/src/tcsd/tcsd_threads.c
index a061ab9..bf7cc6e 100644
--- a/src/tcsd/tcsd_threads.c
+++ b/src/tcsd/tcsd_threads.c
@@ -11,12 +11,18 @@
 
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <syslog.h>
+#endif
 #include <errno.h>
 #include <string.h>
+#ifndef WIN32
 #include <unistd.h>
+#endif
 #include <sys/types.h>
+#ifndef WIN32
 #include <sys/socket.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
@@ -28,6 +34,12 @@
 #include "tcslog.h"
 #include "rpc_tcstp_tcs.h"
 
+#ifdef WIN32
+#include <ws2tcpip.h>
+#include <windows.h>
+#include "libc_interface.h"
+#endif
+
 struct tcsd_thread_mgr *tm = NULL;
 
 TSS_RESULT
@@ -180,6 +192,7 @@ out:
 void
 thread_signal_init()
 {
+#ifndef WIN32
 	sigset_t thread_sigmask;
 	int rc;
 
@@ -194,6 +207,7 @@ thread_signal_init()
 		LogError("worker thread %ld is exiting prematurely", THREAD_ID);
 		THREAD_EXIT(NULL);
 	}
+#endif
 }
 #if 0
 void *
@@ -450,9 +464,8 @@ tcsd_thread_run(void *v)
 	data->thread_id = THREAD_NULL;
 	pthread_mutex_unlock(&(tm->lock));
 	pthread_exit(NULL);
-#else
-	return NULL;
 #endif
+	return NULL;
 }
 
 #endif
diff --git a/src/tddl/tddl.c b/src/tddl/tddl.c
index b4f95b2..c52494f 100644
--- a/src/tddl/tddl.c
+++ b/src/tddl/tddl.c
@@ -1,4 +1,3 @@
-
 /*
  * Licensed Materials - Property of IBM
  *
@@ -9,12 +8,21 @@
  */
 
 
+#ifndef WIN32
 #include <unistd.h>
+#endif
 #include <fcntl.h>
+#ifdef WIN32
+#include <ws2tcpip.h>
+#include <windows.h>
+#include "libc_interface.h"
+#endif
 #include <stdio.h>
 #include <errno.h>
 #include <string.h>
+#ifndef WIN32
 #include <sys/ioctl.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
@@ -22,6 +30,7 @@
 #include "tcslog.h"
 #include "tddl.h"
 
+#ifndef WIN32
 struct tpm_device_node tpm_device_nodes[] = {
 	{"/dev/tpm0", TDDL_UNDEF, TDDL_UNDEF},
 	{"/udev/tpm0", TDDL_UNDEF, TDDL_UNDEF},
@@ -30,11 +39,16 @@ struct tpm_device_node tpm_device_nodes[] = {
 };
 
 struct tpm_device_node *opened_device = NULL;
+#else
+struct tpm_device_node opened_device;
+int tddli_dh = -1;
+#endif
 
 BYTE txBuffer[TDDL_TXBUF_SIZE];
 TSS_BOOL use_in_socket = FALSE;
 struct tcsd_config *_tcsd_options = NULL;
 
+#ifndef WIN32
 #include <sys/socket.h>
 #include <sys/un.h>
 #include <netinet/in.h>
@@ -116,10 +130,74 @@ open_device()
 	}
 	return fd;
 }
+#else
+TSS_RESULT open_device(const char *device_name)
+{
+	/* open the named pipe and generate a posix file handle */
+	DWORD mode = PIPE_TYPE_MESSAGE | PIPE_READMODE_MESSAGE;
+	HANDLE ph = CreateFile(device_name, GENERIC_READ | GENERIC_WRITE,
+				0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
+	SetNamedPipeHandleState(ph, &mode, NULL, NULL);
+	tddli_dh = _open_osfhandle((DWORD)ph, O_RDWR | O_BINARY);
+	if (tddli_dh < 0)
+		return TDDLERR(TDDL_E_FAIL);
+
+	return TSS_SUCCESS;
+}
+
+TSS_RESULT send_to_tpm(BYTE* pTransmitBuf, UINT32 TransmitBufLen)
+{
+	ssize_t res;
+	res = write(tddli_dh, pTransmitBuf, TransmitBufLen);
+	if (res < 0 || (UINT32)res != TransmitBufLen) 
+		return TDDL_E_IOERROR;
+
+	return TSS_SUCCESS;
+}
+
+TSS_RESULT receive_from_tpm(BYTE* pReceiveBuf, UINT32* puntReceiveBufLen)
+{
+	ssize_t res;
+	UINT32 len;
+	if (*puntReceiveBufLen < 10)
+		return TDDL_E_INSUFFICIENT_BUFFER;
+	res = read(tddli_dh, pReceiveBuf, *puntReceiveBufLen);
+	if (res < 10)
+		return TDDL_E_IOERROR;
+	*puntReceiveBufLen = res;
+	len = ((UINT32)pReceiveBuf[2] << 24) | ((UINT32)pReceiveBuf[3] << 16)
+	      | ((UINT32)pReceiveBuf[4] << 8) | (UINT32)pReceiveBuf[5];
+	if (len != *puntReceiveBufLen)
+		return TDDL_E_INSUFFICIENT_BUFFER;
+
+	return TSS_SUCCESS;
+}
+#endif
 
 TSS_RESULT
 Tddli_Open()
 {
+#ifdef WIN32
+	HRESULT hr;
+	LPTSTR tpm_device_name = TEXT("\\\\.\\pipe\\tpmd:0"); 
+
+	if (opened_device.hContext != 0 || tddli_dh != -1) {
+		LogDebug("attempted to re-open the TPM driver!");
+		return TDDLERR(TDDL_E_ALREADY_OPENED);
+	}
+
+	opened_device.contextParams.version = TBS_CONTEXT_VERSION_ONE;
+	hr = Tbsi_Context_Create(&opened_device.contextParams,
+				 &opened_device.hContext);
+	if (FAILED(hr)) {
+		LogDebug("Failed to contact TPM Base Services, trying to connect to TPM Emulator...");
+		hr = open_device(tpm_device_name);
+		if (hr != TSS_SUCCESS) {
+			LogError("Failed to find an available TPM!");
+			return TDDLERR(TDDL_E_FAIL);
+		}
+	}
+#else
 	int rc;
 
 	if (opened_device != NULL) {
@@ -138,12 +216,27 @@ Tddli_Open()
 		return TDDLERR(TDDL_E_FAIL);
 	}
 
+#endif
 	return TSS_SUCCESS;
 }
 
 TSS_RESULT
 Tddli_Close()
 {
+#ifdef WIN32
+	if (opened_device.hContext == 0 && tddli_dh == -1) {
+		LogDebug("attempted to re-close the TPM driver!");
+		return TDDLERR(TDDL_E_ALREADY_CLOSED);
+	}
+
+	if (opened_device.hContext != 0) {
+		Tbsip_Context_Close(opened_device.hContext);
+		opened_device.hContext = 0;
+	} else {
+		close(tddli_dh);
+		tddli_dh = -1;
+	}
+#else	
 	if (opened_device == NULL) {
 		LogDebug("attempted to re-close the TPM driver!");
 		return TDDLERR(TDDL_E_ALREADY_CLOSED);
@@ -153,6 +246,7 @@ Tddli_Close()
 	opened_device->fd = TDDL_UNDEF;
 	opened_device = NULL;
 
+#endif
 	return TSS_SUCCESS;
 }
 
@@ -161,6 +255,8 @@ Tddli_TransmitData(BYTE * pTransmitBuf, UINT32 TransmitBufLen, BYTE * pReceiveBu
 		   UINT32 * pReceiveBufLen)
 {
 	int sizeResult;
+#ifdef WIN32
+	HRESULT hr;
 
 	if (TransmitBufLen > TDDL_TXBUF_SIZE) {
 		LogError("buffer size handed to TDDL is too large! (%u bytes)", TransmitBufLen);
@@ -168,6 +264,40 @@ Tddli_TransmitData(BYTE * pTransmitBuf, UINT32 TransmitBufLen, BYTE * pReceiveBu
 	}
 
 	memcpy(txBuffer, pTransmitBuf, TransmitBufLen);
+	sizeResult = sizeof(txBuffer);
+	LogDebug("Calling write to driver");
+
+	if (opened_device.hContext != 0) {
+		hr = Tbsip_Submit_Command(opened_device.hContext,
+								  TBS_COMMAND_LOCALITY_ZERO,
+								  TBS_COMMAND_PRIORITY_NORMAL,
+								  txBuffer,
+								  TransmitBufLen,
+								  txBuffer,
+								  (unsigned *)&sizeResult);
+		if (FAILED(hr)) {
+			return TDDLERR(TDDL_E_FAIL);
+		}
+
+		if ((unsigned)sizeResult > *pReceiveBufLen) {
+			return TDDLERR(TDDL_E_INSUFFICIENT_BUFFER);
+		}
+	} else if (tddli_dh != -1) {
+		hr = send_to_tpm(txBuffer, TransmitBufLen);
+		if (hr != TSS_SUCCESS)
+			return TDDLERR(TDDL_E_FAIL);
+		
+		hr = receive_from_tpm(txBuffer, (unsigned *)&sizeResult);
+		if (hr != TSS_SUCCESS)
+			return TDDLERR(TDDL_E_FAIL);
+	}
+#else
+	if (TransmitBufLen > TDDL_TXBUF_SIZE) {
+		LogError("buffer size handed to TDDL is too large! (%u bytes)", TransmitBufLen);
+		return TDDLERR(TDDL_E_FAIL);
+	}
+
+	memcpy(txBuffer, pTransmitBuf, TransmitBufLen);
 	LogDebug("Calling write to driver");
 
 	if (use_in_socket) {
@@ -227,6 +357,7 @@ Tddli_TransmitData(BYTE * pTransmitBuf, UINT32 TransmitBufLen, BYTE * pReceiveBu
 		return TDDLERR(TDDL_E_INSUFFICIENT_BUFFER);
 	}
 
+#endif
 	*pReceiveBufLen = sizeResult;
 
 	memcpy(pReceiveBuf, txBuffer, *pReceiveBufLen);
@@ -246,15 +377,101 @@ Tddli_SetCapability(UINT32 CapArea, UINT32 SubCap,
 	return TDDLERR(TSS_E_NOTIMPL);
 }
 
+#ifdef WIN32
+static TSS_RESULT cap_version(UINT32 SubCap, BYTE* pCapBuf,
+                              UINT32* puntCapBufLen)
+{
+	TSS_RESULT res;
+	UINT32 len = 18;
+	BYTE buf[18];
+
+	switch (SubCap) {
+	case TDDL_CAP_VER_DRV:
+		if (*puntCapBufLen < 4) return TDDL_E_INSUFFICIENT_BUFFER;
+		*puntCapBufLen = 4;
+		memcpy(pCapBuf, "\x01\x05\x00\x00", 4);
+		return TSS_SUCCESS;
+
+	case TDDL_CAP_VER_FW:
+		if (*puntCapBufLen < 4) return TDDL_E_INSUFFICIENT_BUFFER;
+		*puntCapBufLen = 4;
+		res = send_to_tpm((BYTE *)"\x00\xc1\x00\x00\x00\x12\x00\x00\x00\x65"
+		  "\x00\x00\x00\x06\x00\x00\x00\x00", 18);
+		if (res != TSS_SUCCESS)
+			return res;
+		res = receive_from_tpm(buf, &len);
+		if (res != TSS_SUCCESS)
+			return res;
+		if (len != 18 || (buf[6] | buf[7] | buf[8] | buf[9]) != 0)
+			return TDDL_E_FAIL;
+		memcpy(pCapBuf, &buf[14], 4);
+		return TSS_SUCCESS;
+
+	case TDDL_CAP_VER_FW_DATE:
+		/* this is not yet supported by the TPM emulator */
+		return TDDLERR(TSS_E_NOTIMPL);
+
+	default:
+		return TDDLERR(TSS_E_BAD_PARAMETER);
+	}
+}
+
+static TSS_RESULT cap_property(UINT32 SubCap, BYTE* pCapBuf,
+                               UINT32* puntCapBufLen)
+{
+	static const char *manufacturer = "Mario Strasser, ETH Zurich";
+	static const char *type = "Software-based TPM Emulator";
+
+	switch (SubCap) {
+	case TDDL_CAP_PROP_MANUFACTURER:
+		if (*puntCapBufLen < strlen(manufacturer))
+			return TDDL_E_INSUFFICIENT_BUFFER;
+		*puntCapBufLen = strlen(manufacturer);
+		memcpy(pCapBuf, manufacturer, *puntCapBufLen);
+		return TSS_SUCCESS;
+
+	case TDDL_CAP_PROP_MODULE_TYPE:
+		if (*puntCapBufLen < strlen(type)) 
+			return TDDL_E_INSUFFICIENT_BUFFER;
+		*puntCapBufLen = strlen(type);
+		memcpy(pCapBuf, type, *puntCapBufLen);
+		return TSS_SUCCESS;
+
+	default:
+		return TDDLERR(TSS_E_BAD_PARAMETER);
+	}
+}
+#endif
+
 TSS_RESULT
 Tddli_GetCapability(UINT32 CapArea, UINT32 SubCap,
 		    BYTE *pCapBuf, UINT32 *pCapBufLen)
 {
+#ifdef WIN32
+	TSS_RESULT res = TSS_SUCCESS;
+	if (tddli_dh < 0) 
+		return TDDL_E_FAIL;
+	switch (CapArea) {
+	case TDDL_CAP_VERSION:
+		res = cap_version(SubCap, pCapBuf, pCapBufLen);    
+		break;
+	case TDDL_CAP_PROPERTY:
+		res = cap_property(SubCap, pCapBuf, pCapBufLen);
+		break;
+	default:
+		res = TDDLERR(TSS_E_BAD_PARAMETER);
+	}
+	return res;
+#else
 	return TDDLERR(TSS_E_NOTIMPL);
+#endif
 }
 
 TSS_RESULT Tddli_Cancel(void)
 {
+#ifdef WIN32
+	return TSS_E_NOTIMPL;
+#else
 	int rc;
 
 	if (opened_device->transmit == TDDL_TRANSMIT_IOCTL) {
@@ -270,4 +487,5 @@ TSS_RESULT Tddli_Cancel(void)
 	} else {
 		return TDDLERR(TSS_E_NOTIMPL);
 	}
+#endif
 }
